function TOUCH(id, mouseblock)
{
	this.id			= id;
	this.mouseblock		= mouseblock || 0;
	this.startX		= 0;
	this.startY		= 0;
	this.currentX		= 0;
	this.currentY		= 0;
	this.stopX		= 0;
	this.stopY		= 0;
	this.delta_abs_x	= 0;
	this.delta_abs_y	= 0;
	this.delta_x		= 0;
	this.delta_y		= 0;

	this.drag		= false;
	this.drag_block		= false;
	this.hooks		= [];
	this.functions		= [];

	this.BaseHook = function(event, handler)
	{
	        this.hooks[event] = [];
		$('#'+this.id).on(event, handler);
	}
	this.FunctionalHook = function(func, handler)
	{
		if (this.functions[func] === undefined)
			this.functions[func] = [];
		if (handler)
			this.functions[func][this.functions.length] = handler;
	}
	this.DragStart = function (X, Y)
	{

		if (!this.drag && !this.drag_block)
		{
			this.drag	= true;
			this.startX	= X;
			this.startY	= Y;
			this.stopX	= X;
			this.stopY	= Y;
			this.delta_abs	= 0;
			for (var key in this.functions['dragstart'])
			{
				this.functions['dragstart'][key](this.startX, this.startY, this);
			}
		}
	}
	this.DragEnd = function ()
	{
		this.drag = false;
		this.startX = 0;
		this.startY = 0;
		for (var key in this.functions['dragend'])
		{
			this.functions['dragend'][key](this.currentX, this.currentY, this);
		}
		this.currentX = 0;
		this.currentY = 0;

	}
	this.DragMove = function()
	{
		var currentItem;
		var line = '';
		var sizeReal;

		this.delta_x =  this.currentX - this.stopX;
		this.delta_y =  this.currentY - this.stopY;

		this.stopX	= this.currentX;
		this.stopY	= this.currentY;

		this.delta_abs_x += this.delta_x;
		this.delta_abs_y += this.delta_y;

		for (var key in this.functions['move'])
		{
			this.functions['move'][key](this.currentX, this.currentY, this);
		}

	}
	this.OnClick = function (X, Y)
	{
		for (var key in this.functions['click'])
		{
			this.functions['click'][key](X, Y);
		}
	}
	this.onMouseDragStart = function (event)
	{
		this.DragStart(event.pageX, event.pageY);
		return false;
	}
	this.onMouseDragEnd = function(event)
	{
		this.currentX	= event.pageX;
		this.currentY	= event.pageY;
		this.DragEnd();
	}
	this.onMouseMove = function(event)
	{
		var delta;
		if (this.drag)
		{
			this.currentX	= event.pageX;
			this.currentY	= event.pageY;
			this.DragMove();
		}
		return false;
	}
	this.onMouseClick = function (event)
	{
		this.OnClick(event.pageX, event.pageY);
		return true;
	}
	this.onTouchStart = function (event)
	{
		var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];
		this.DragStart(touch.pageX, touch.pageY);
		return false;
	}
	this.onTouchEnd = function(event)
	{
		var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];

		this.currentX	= touch.pageX;
		this.currentY	= touch.pageY;
		this.DragEnd();
	}
	this.onTouchMove = function(event)
	{
		if (this.drag)
		{
			var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];
			this.currentX	= touch.pageX;
			this.currentY	= touch.pageY;
			this.DragMove();
		}
		return false;
	}
	this.onTap = function(event)
	{
		var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];
		this.OnClick(touch.pageX, touch.pageY);
		return false;
	}
	this.SetGrid = function()
	{
	}
	if (!this.mouseblock)
	{
		this.BaseHook('mousedown', $.proxy(this.onMouseDragStart, this));
		this.BaseHook('mouseup', $.proxy(this.onMouseDragEnd, this));
		this.BaseHook('mousemove', $.proxy(this.onMouseMove, this));
		this.BaseHook('click', $.proxy(this.onMouseClick, this));

	}

	this.BaseHook('tap', $.proxy(this.onTap, this));
	this.BaseHook('touchstart', $.proxy(this.onTouchStart, this));
	this.BaseHook('touchend', $.proxy(this.onTouchEnd, this));
	this.BaseHook('touchmove', $.proxy(this.onTouchMove, this));

	this.FunctionalHook('click');
	this.FunctionalHook('move');
	this.FunctionalHook('dragstart');
	this.FunctionalHook('dragend');
}